<script>
  import {scaleLinear, scaleOrdinal} from "d3-scale";
  import {axisBottom, axisLeft} from "d3-axis";
  import {extent} from "d3-array";
  import {schemeTableau10} from "d3-scale-chromatic";
  import { select } from "d3-selection";
  import { format } from "d3-format";

  export let data;
  // Dimensions
  const [height, width] = [400, 600];
  const margin = { top: 50, right: 5, bottom: 55, left: 50 };
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  
  const scalePopu = scaleLinear().domain(extent(data.countries,country=>country.population)).range([5,15]);
  const scaleIncom = scaleLinear().domain([1,10000]).range([0,innerWidth]);
  const scaleLife = scaleLinear().domain([0,90]).range([innerHeight,0]);
  const scaleCol = scaleOrdinal().domain([...new Set(data.countries.map(country => country.continent))]).range(schemeTableau10);

  let xLabels = ["$400","$4000","$40000"];

  function xAxis(element) {
    const x_axis=axisBottom(scaleIncom).tickValues([400,4200,8000]).tickFormat((d,i)=>xLabels[i]);
          x_axis(select(element));
  };

  function yAxis(element) {
    const y_axis=axisLeft(scaleLife);
          y_axis(select(element));
  };

  

</script>

<svg viewBox="0 0 {width} {height}" style="max-width: {width}px">
  <g transform="translate({margin.left}, {margin.top})">
    {#each data.countries as d}
    {#if d.income!= undefined && d.life_exp!= undefined}
    <circle cx={scaleIncom(+d.income)} cy={scaleLife(+d.life_exp)} r={scalePopu(+d.population)} style={"fill:"+scaleCol(d.continent)}>
    <title>{d.country}</title>
    </circle>
    {/if}
    {/each}
    <g use:xAxis transform="translate(0,{innerHeight})"></g>
    <g use:yAxis></g>
    <text x=200 y={innerHeight+35}>GDP per Capita</text>
    <text id="le" x=-200 y=-30 transform="rotate(-90)">Life Expectancy</text>
    <text style="font-size:40px;" x=100 y=10>Gapminder Scatterplot</text>
    <text x={innerWidth-100} y={innerHeight-10} style="fill:grey; opacity:0.7; font-size: 2.7em;">1800</text>

  </g>
  

</svg>


